package INF555_NielsenFrank;

// To save an image we need to convert Image to BufferedImage first

// Attention: If you save in JPG, you have to agree on the color model first. 
 
import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.awt.image.ImageProducer;
import javax.imageio.ImageIO ;
import java.io.*; 
import javax.imageio.*;

public class INF555_ModifyImagePixels
{
public static void main(String [] args)
{
PixelGrabber pg;
 String filenameimg="liftoff.jpg";
//String filenameimg="essai.png";
int[] raster=null; 
int x,y,w=0,h=0;
int red,green,blue,alpha,index;
int r,g,b, a, rgba;
int rastero[]=null;

Toolkit tk=Toolkit.getDefaultToolkit();
Image img = tk.getDefaultToolkit().getImage(filenameimg); 
ImageProducer ip;
Image imgresult;


if (img!=null)
        {
         pg = new PixelGrabber(img, 0 , 0 , -1 , -1 , true);
         try { pg.grabPixels(); } catch (InterruptedException e) { }
		 raster= (int[])pg.getPixels();
        w=pg.getWidth();
        h=pg.getHeight();
        System.out.println("Image width w="+w+" height="+h);
        rastero=new int[w*h];
        }     
  else
  {
  System.out.println("Image not found");	
  System.exit(-1);	
  }      
  
 
// Extract all pixels (inefficient)      
for (y = 0; y < h; y++) {
            for (x = 0; x < w ; x++) {
            	index=y*w+x; // index in the array
            	
            	int [] pixels=raster;
            	
            	alpha = ( pixels [index ] & 0xff000000 ) >> 24;
red = ( pixels [index ] & 0x00ff0000 ) >> 16;
green = ( pixels [ index  ] & 0x0000ff00 ) >> 8;
blue = ( pixels [ index ] & 0x000000ff );
//do manipulations here
rastero [ index ] = ( (alpha << 24) | (red << 16) | (green << 8) | blue);

            	
            	/*
                blue = (raster[y * w+ x] & 0xFF) ;   
                green = ((raster[y *w+ x] & 0xFF00) >> 8);   
                red = ((raster[y *w + x] & 0xFF0000) >> 16);
				alpha = (raster[y *w + x] & 0xff000000) >> 24;
  */
                
                //System.out.println(red+" "+green+" "+blue);
                
                // Compute the gradient on x-axis here
                //a=255;
                //r=red;
                //g=green;
                //b=blue;
                // or a << 24
                //rgba=(0xff000000 | b << 16 | g << 8 | r);
                //rgba=alpha << 24 | red << 16 | green << 8 | blue;

                /*
                 *r  = r   & 0x00ff0000;
	    		g = g <<8 & 0x0000ff00;
	    		b=b << 16 & 0x000000ff;
	   			rgba = 0xff000000 | red | green | blue;
	   			*/
                //rastero[y *w + x]=rgba;
            }
        }	// end for
        
        
imgresult = tk.createImage(new MemoryImageSource(w,h,rastero,0,w));
// Convert to bufferedimage now

BufferedImage bimgresult=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
Graphics2D gc= bimgresult.createGraphics();
gc.drawImage(imgresult,0,0,w,h,null);


// Try to save in JPG and observe color problems...
File f = new File ("gradient.png"); 

try {ImageIO.write (bimgresult, "png", f); }
catch (Exception e){} 
         
}	
}
	
