// Read all pixels in a given image (Frank NIELSEN)
package INF555_NielsenFrank;

import java.awt.*;
import java.awt.image.*;
import java.net.*;

public class INF555_ReadImagePixels
{
public static void main(String [] args)
{
PixelGrabber pg;
String filenameimg="liftoff.jpg";
int[] raster=null; 
int x,y,w=0,h=0;
int red,green,blue,index;

Toolkit tk=Toolkit.getDefaultToolkit();
Image img = tk.getDefaultToolkit().getImage(filenameimg); 

if (img!=null)
        {
         pg = new PixelGrabber(img, 0 , 0 , -1 , -1 , true);
         try { pg.grabPixels(); } catch (InterruptedException e) { }
		 raster= (int[])pg.getPixels();
        w=pg.getWidth();
        h=pg.getHeight();
        System.out.println("Image width w="+w+" height="+h);
        }     
  else
  {
  System.out.println("Image not found");	
  System.exit(-1);	
  }      
// Extract all pixels (inefficient)      
for (y = 0; y < h; y++) {
            for (x = 0; x < w ; x++) {
            	index=y*w+x;
            	
                red = (raster[y * w+ x] & 0xFF) ;   
                green = ((raster[y *w+ x] & 0xFF00) >> 8);   
                blue = ((raster[y *w + x] & 0xFF0000) >> 16);
            // Transparency attribute a is with >>24
           //System.out.println(red+" "+green+" "+blue);
            }
        }	
}	
}
	
